"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.BemTools = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireWildcard(require("react"));
var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");
var _borderDetecting = require("./border-detecting");
var _borderContainer = require("./border-container");
var _borderSelecting = require("./border-selecting");
var _borderResizing = _interopRequireDefault(require("./border-resizing"));
var _insertion = require("./insertion");
require("./bem-tools.less");
require("./borders.less");
var _class;
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var BemTools = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(BemTools, _Component);
  function BemTools() {
    return _Component.apply(this, arguments) || this;
  }
  var _proto = BemTools.prototype;
  _proto.render = function render() {
    var host = this.props.host;
    var designMode = host.designMode;
    var _host$viewport = host.viewport,
      scrollX = _host$viewport.scrollX,
      scrollY = _host$viewport.scrollY,
      scale = _host$viewport.scale;
    if (designMode === 'live') {
      return null;
    }
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "lc-bem-tools",
      style: {
        transform: "translate(" + -scrollX * scale + "px," + -scrollY * scale + "px)"
      }
    }, !_lowcodeEditorCore.engineConfig.get('disableDetecting') && /*#__PURE__*/_react["default"].createElement(_borderDetecting.BorderDetecting, {
      key: "hovering",
      host: host
    }), /*#__PURE__*/_react["default"].createElement(_borderSelecting.BorderSelecting, {
      key: "selecting",
      host: host
    }), _lowcodeEditorCore.engineConfig.get('enableReactiveContainer') && /*#__PURE__*/_react["default"].createElement(_borderContainer.BorderContainer, {
      key: "reactive-container-border",
      host: host
    }), /*#__PURE__*/_react["default"].createElement(_insertion.InsertionView, {
      key: "insertion",
      host: host
    }), /*#__PURE__*/_react["default"].createElement(_borderResizing["default"], {
      key: "resizing",
      host: host
    }), host.designer.bemToolsManager.getAllBemTools().map(function (tools) {
      var ToolsCls = tools.item;
      return /*#__PURE__*/_react["default"].createElement(ToolsCls, {
        key: tools.name,
        host: host
      });
    }));
  };
  return BemTools;
}(_react.Component)) || _class;
exports.BemTools = BemTools;